import { useAssetsStore } from '../../../../store/builder/useAssetStore';
import Model from './model/model';
import { useThree } from '@react-three/fiber';
import { CameraControls } from '@react-three/drei';
import { Vector3 } from 'three';
import { useSelectedFloorItem } from '../../../../store/builder/store';

function Models() {
    const { controls } = useThree();
    const { assets } = useAssetsStore();
    const { selectedFloorItem, setSelectedFloorItem } = useSelectedFloorItem();

    return (
        <group
            name='Asset Group'
            onPointerMissed={(e) => {
                e.stopPropagation();
                if (selectedFloorItem) {
                    const target = (controls as CameraControls).getTarget(new Vector3());
                    (controls as CameraControls).setTarget(target.x, 0, target.z, true);
                    setSelectedFloorItem(null);
                }
            }}
        >
            {assets.map((asset) =>
                <Model key={asset.modelUuid} asset={asset} />
            )}
        </group>
    )
}

export default Models